#!/usr/local/bin/perl
#
#
# This script enables the upload of files to a web server.
# No files are overwritten. (This includes the correct handling 
# of files carrying identical names). If one and the same file 
# is transfered twice, it is uploaded only once. 
# This script is part of an online file handling tool.
# Before action is possible, a permission check according to
# this tool is performed.
#
# February/March 2000
#
# Part of this script has been taken over from Jeffrey D. Carnahan (1996)
# http://www.terminalp.com/scripts/scripts.shtml
#

BEGIN 
{ 
  $MAXIMUM_UPLOAD = 1050000;  # Obergrenze fr Files zum Uploaden (falls 0 -> kein Check)
  $ALLOW_INDEX = 0;           # wenn 0 -> Files drfen nicht mit 'index' beginnen (Wenn 1 -> kein Check)
  $SUCCESS_LOCATION = "";     # URL fr Rckmeldung, falls gewnscht
}

$| = 1;

use CGI qw(:standard);
$query = new CGI;

# Zielverzeichnis einlesen:
$relativer_pfad = $query->param('pfd');

$doppelt = 0;

# Berechtigung checken und @filenamen ermitteln 
require 'verz_check.cgi';
&berechtigung_checken($relativer_pfad); 


if ($query->param('frames') eq "0")
{ $reloaddir = "window.opener.location = window.opener.location;"; }
else
{ $reloaddir = "top.frames[0].document.location = top.frames[0].document.location;"; }

chop $relativer_pfad if ($relativer_pfad =~ /\/$/);  # Slash am Ende wegzwicken?

    # Die bereits im Verzeichnis vorhandenen Filenamen:
    # opendir(VERZ,$relativer_pfad);
    # @filenamen = readdir(VERZ);
    # closedir(VERZ);
    # (wird oben in &berechtigung_checken($relativer_pfad) ermittelt)

	if ( (!(-e $relativer_pfad)) ||
		 (!(-W $relativer_pfad)) ||
		 (!(-d $relativer_pfad)) ) {
		print header;
		print <<RUECKMELDUNG;
		
		<HTML>
		<HEAD>
			<TITLE>Fehler: Zugriff auf Verzeichnis verweigert</TITLE>
		</HEAD>
		<BODY BACKGROUND="bg.gif"><FONT FACE="Arial,Helvetica" SIZE="-1">
		<B>Fehler: Zugriff verweigert</B>
		<P>
		Das angegebene Zielverzeichnis
		<BR>
		<BLOCKQUOTE>
			<TT>\$relativer_pfad = "<B>$relativer_pfad</B>";</TT>
		</BLOCKQUOTE>
		<BR>
		ist ung&uuml;ltig. Der Grund daf&uuml;r kann sein:
		<OL>
			<LI>Es existiert nicht (es mu&szlig; als kompletter Pfad definiert sein, nicht als URL). 
            Es sollte wie <TT>/home/username/public_html/uploads</TT> aussehen.
			<P>
			<LI>Keine Schreibberechtigung. Sie m&uuml;&szlig; f&uuml;r alle Benutzer gegeben sein.
			Unter Unix, versuchen Sie <TT>chmod 777 $relativer_pfad</TT>.
			<P>
			<LI>Der angegebene Pfad verweist nicht auf ein Verzeichnis, sondern auf eine Datei.
		</OL>
		</FONT>
		</BODY>
		</HTML>
		
RUECKMELDUNG
		exit;
	}


	foreach $key (sort {$a <=> $b} $query->param()) {   # $a <=> $b ... numerische Ordnung
		next if ($key =~ /^\s*$/);                 # wenn Formular-Variable nur aus Leerzeichen etc besteht
		next if ($query->param($key) =~ /^\s*$/);  # wenn Dateiname nur aus Leerzeichen etc besteht
		next if ($key !~ /^file_upl_(\d+)$/);      # wenn Formular-Variable nicht die Form file_upl_...Zahlen... hat
		# doppelte Formwerte (d.h. 2x dasselbe File abschicken) ausschliessen
		next if (auslassen($query->param($key)) eq 1);	# wenn ein Dateiname zweimal vorkommt
		$Number = $1;					
		
		if ($query->param($key) =~ /([^\/\\]+)$/)    # keine Schrgstriche am Ende
		  { 
			$Filename = $1;                    # das "Ende" des Pfades, d.h. der Filename!
			$Filename =~ s/^\s+//;             # Leerzeichen am Anfang entfernen			
			$Filename =~ s/^\.+//;             # Punkt(e) am Anfang wegzwicken
			
			$Filename =~ s/^\s+//;       # nochmals Leerzeichen am Anfang entfernen
			$Filename =~ s/(\s+)$//;     # Leerzeichen am Ende entfernen
			$Filename =~ s/ /_/g;        # Leerzeichen in der Mitte durch _ ersetzen
			$Filename =~ s/^\.+//;       # nochmals: Punkt(e) am Anfang wegzwicken

			$File_Handle = $query->param($key);
			
			
			if (!$ALLOW_INDEX && $Filename =~ /^index/i) {
			    $FILENAME_IN_QUESTION = $query->param($key);
				print header;
				print <<RUECKMELDUNG;
				
				<HTML>
				<HEAD>
			    <TITLE>Problem mit Dateinamen</TITLE>
				</HEAD>
                <BODY BACKGROUND="bg.gif" LINK="#0000CC" VLINK="#000099" ALINK="#009999"><FONT FACE="Arial,Helvetica" SIZE="-1">
                <B>Problem mit Dateinamen</B>:
				<BR>
				Bitte &auml;ndern Sie den Namen der Datei <FONT FACE='Courier' SIZE='-1'>$FILENAME_IN_QUESTION</FONT>&nbsp;!<BR>
		        Dateien, deren Name mit '<FONT FACE='Courier' SIZE='-1'>index</FONT>' beginnt, k&ouml;nnen aus Sicherheitsgr&uuml;nden 
				nicht upgeloadet werden. &nbsp;
				<A HREF="javascript:history.back()">Zur&uuml;ck</A>
				</FONT>
				</BODY>
				</HTML>
	
RUECKMELDUNG
				exit;
			}
			elsif (        # NICHT ERLAUBTE SONDERZEICHEN:
			        ($Filename =~ /\&/) || ($Filename =~ /\+/) ||
			        ($Filename =~ /\?/) || ($Filename =~ /;/)  ||   # ; muss schon auf der Webseite abgefangen werden
				    ($Filename =~ /\%/) || ($Filename =~ /\#/) || 
					($Filename =~ /\=/) || ($Filename =~ /\"/) ||   # " muss schon auf der Webseite abgefangen werden
					($Filename =~ /\'/)                             # ' muss schon auf der Webseite abgefangen werden
				  )
			{
			$FILENAME_IN_QUESTION = $query->param($key);			
			print header;
			print <<RUECKMELDUNG;
			
			<HTML>
			<HEAD>
				<TITLE>Problem mit Dateinamen</TITLE>
			</HEAD>
                <BODY BACKGROUND="bg.gif" LINK="#0000CC" VLINK="#000099" ALINK="#009999"><FONT FACE="Arial,Helvetica" SIZE="-1">
                <B>Problem mit Dateinamen</B>:
		        <BR>
				Bitte &auml;ndern Sie den Namen der Datei 
				<FONT FACE='Courier' SIZE='-1'>$FILENAME_IN_QUESTION</FONT>&nbsp;!<BR>
				Er sollte die Zeichen
				<FONT FACE='Courier' SIZE='-1'>&amp;</FONT>,
				<FONT FACE='Courier' SIZE='-1'>+</FONT>, <FONT FACE='Courier' SIZE='-1'>?</FONT>,
				<FONT FACE='Courier' SIZE='-1'>;</FONT>, <FONT FACE='Courier' SIZE='-1'>%</FONT>,
				<FONT FACE='Courier' SIZE='-1'>#</FONT>, <FONT FACE='Courier' SIZE='-1'>=</FONT>,
				<FONT FACE='Courier' SIZE='-1'>"</FONT> und <FONT FACE='Courier' SIZE='-1'>'</FONT>
				nicht enthalten.
				&nbsp;
			    <A HREF="javascript:history.back()">Zur&uuml;ck</A>
			</FONT>
			</BODY>
			</HTML>

RUECKMELDUNG
			exit;			
			}
			
		} else {
			$FILENAME_IN_QUESTION = $query->param($key);
			
			print header;
			print <<RUECKMELDUNG;
			
			<HTML>
			<HEAD>
				<TITLE>Problem mit Dateinamen</TITLE>
			</HEAD>
                <BODY BACKGROUND="bg.gif" LINK="#0000CC" VLINK="#000099" ALINK="#009999"><FONT FACE="Arial,Helvetica" SIZE="-1">
                <B>Problem mit Dateinamen</B>:
		        <BR>
				Bitte &auml;ndern Sie den Namen der Datei 
				<FONT FACE='Courier' SIZE='-1'>$FILENAME_IN_QUESTION</FONT>&nbsp;!<BR>
				Dateinamen d&uuml;rfen - zus&auml;tzlich zur Pfadangabe - keine Schr&auml;gstriche 
				(<FONT FACE='Courier' SIZE='-1'>/</FONT> und <FONT FACE='Courier' SIZE='-1'>&#92;</FONT>) 
				enthalten. &nbsp;
			    <A HREF="javascript:history.back()">Zur&uuml;ck</A>
			</FONT>
			</BODY>
			</HTML>

RUECKMELDUNG
			exit;
		}
	
	
# Gibt's ein File gleichen Namens schon?
  &gibtsschon;		

#Fr Fileanzeige:  
 $uaux{$File_Handle} = &entf("$scriptverzeichnis/$relativer_pfad\/$Filename");

        if (!open(OUTFILE, ">$relativer_pfad\/$Filename")) {
            print "Content-type: text/html\n\n";
            print "<HTML><HEAD><TITLE>Fehler</TITLE></HEAD><BODY BACKGROUND='bg.gif' LINK='#0000CC' VLINK='#000099' ALINK='#009999'>\n";
			print "<CENTER><BR><TABLE WIDTH='95%' BORDER='0'>\n";
			print "<TD WIDTH='20%' ALIGN='left'><FONT FACE='Arial,Helvetica' SIZE='-1'>&nbsp;&nbsp;<B>Fehler</B>:</FONT></TD>\n";
			print "<TD WIDTH='60%'ALIGN='center'><FONT FACE='Arial,Helvetica' SIZE='-1'>Fehlermeldung:</FONT\n";
			print ">&nbsp; <FONT FACE='Courier' SIZE='-1'> $! </FONT></TD><TD WIDTH='20%' ALIGN='right'";
			print "><FONT FACE='Arial,Helvetica' SIZE='-1'><A HREF='javascript:history.back();'>Zur&uuml;ck</A>&nbsp;&nbsp;</FONT></TD></TABLE>\n";
            print "</CENTER></BODY></HTML>";
            exit;
        }

		undef $BytesRead;
		undef $Buffer;		
	
        while ($Bytes = read($File_Handle,$Buffer,1024)) {
			$BytesRead += $Bytes;
            print OUTFILE $Buffer;
        }

		push(@Files_Written, "$relativer_pfad\/$Filename");
		$TOTAL_BYTES += $BytesRead;
		$Confirmation{$File_Handle} = $BytesRead;

        close($File_Handle);
		close(OUTFILE);

        chmod (0666, "$relativer_pfad\/$Filename");
		
 # Default-Titel in das Berechtigungs-File schreiben (anhngen):
   open(FILE_SCHREIBEN,">>$relativer_pfad/.06641431691");
   flock(FILE_SCHREIBEN, 2);   
   print FILE_SCHREIBEN "\n\$_titel_{\"$Filename\"} = \"Datei $Filename\";  \# $aktuelle_zeit";    # Titel eintragen
   flock(FILE_SCHREIBEN, 8);
   close(FILE_SCHREIBEN);		
		
		# zum Ausschliessen von doppelten Formwerten (= 2x daselbe File schicken)
		push(@bisherigequeryparams,$query->param($key)); 
    }

	$FILES_UPLOADED = scalar(keys(%Confirmation));

	
	if ($TOTAL_BYTES > $MAXIMUM_UPLOAD && $MAXIMUM_UPLOAD > 0) {
		foreach $File (@Files_Written) {
			unlink $File;
		}
		
		print header;
		print <<RUECKMELDUNG;
		
		<HTML>
		<HEAD>
			<TITLE>Datei zu gro&szlig;</TITLE>
		</HEAD>
        <BODY BACKGROUND="bg.gif" LINK="#0000CC" VLINK="#000099" ALINK="#009999"><FONT FACE="Arial,Helvetica" SIZE="+0">
		<CENTER><!-- BR><BR><BR><BR><BR -->
        <B>Datei(en) zu gro&szlig;!!!</B>
		</CENTER>
		<BR><BR>

		Sie haben versucht, $TOTAL_BYTES Bytes upzuloaden. Das Limit betr&auml;gt
		$MAXIMUM_UPLOAD Bytes.<BR><BR> 
		Es wurde keine Datei gespeichert.
        <BR><!-- BR -->
		<A HREF="javascript:history.back()">Zur&uuml;ck</A>
	    <!-- BR><BR -->
		</FONT>
		</BODY>
		</HTML>
				
RUECKMELDUNG
		exit;
	}
	
	if ($SUCCESS_LOCATION !~ /^\s*$/) {
		print $query->redirect($SUCCESS_LOCATION);
	} else {
	
      if ($FILES_UPLOADED eq 1) 
      { $rueckm1 = "Eine Datei gespeichert";
	    $rueckm2 = "Es wurde eine Datei gespeichert"; 
		if ($doppelt eq 1) { $rueckm2 = $rueckm2." - zumindest zwei Dateien waren identisch"; }
	  }
      else
      { $rueckm1 = "$FILES_UPLOADED Dateien gespeichert";
	    $rueckm2 = "Es wurden $FILES_UPLOADED Dateien gespeichert"; 
		if ($doppelt eq 1) { $rueckm2 = $rueckm2." - zumindest zwei Dateien waren identisch"; }
		}

		print header;
		print <<RUECKMELDUNG;
		
		<HTML>
		<HEAD>
			<TITLE>$rueckm1</TITLE>
		</HEAD>
		<BODY BACKGROUND="bg.gif" LINK="#0000CC" VLINK="#000099" ALINK="#009999">
		
		<!-- oberes Frame (=Anzeige) reloaden -->
		<SCRIPT LANGUAGE="JavaScript">
         $reloaddir
		</SCRIPT>
		
		<CENTER><!-- BR><BR><BR><BR><BR -->
        <TABLE WIDTH="95%" BORDER="0" CELLPADDING="10"><TD WIDTH="10%" ALIGN="left"><FONT FACE="Arial,Helvetica" SIZE="-1">
		<A HREF="javascript:history.back();">Zur&uuml;ck</A>
		</FONT></TD><TD WIDTH="80%" ALIGN="center"><FONT FACE="Arial,Helvetica" SIZE="-1">
		<B>$rueckm2</B>:
		</FONT></TD><TD WIDTH="10%">&nbsp;</TD>
		</TABLE>
        
		<TABLE WIDTH="90%"><TD>
	
RUECKMELDUNG

		foreach $key (keys (%Confirmation)) {
		    if ($Confirmation{$key}) {
		        print $existiert{$key};
			print "<FONT FACE='Courier' SIZE='-1'>$key - $Confirmation{$key} Bytes</FONT><BR>\n";
			print "<FONT FACE='Arial,Helvetica' SIZE='-1'>";
			print "<NOBR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
			print "<A HREF='$uaux{$key}' TARGET='_blank'";
			print ">$uaux{$key}</A></NOBR></FONT><BR><BR>";
			}
			else {
			print $existiert{$key};
			print "<FONT FACE='Arial,Helvetica' SIZE='-1'><B>Mglicher Fehler</B>: Entweder die Datei</FONT><BR>";
                        print "<FONT FACE='Courier' SIZE='-1'>$key</FONT><BR>\n";
			print "<FONT FACE='Arial,Helvetica' SIZE='-1'>existiert nicht, oder sie hat keinen Inhalt. Es wurde eine leere Datei angelegt:<BR>";
			print "<NOBR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
			print "<A HREF='$uaux{$key}' TARGET='_blank'";
			print ">$uaux{$key}</A></NOBR></FONT><BR><BR>";			
			}
		}
        
		print <<RUECKMELDUNG;
		
		</FONT></TD></TABLE>
		</CENTER>
		<!-- BR><BR -->
		</BODY>
		</HTML>

RUECKMELDUNG
		exit;	
	}

sub entf
{
    # Strukturen vom Typ /A/.. aus URLs entfernen
    @teile = split(/\//,$_[0]);
    for ($i=0; $i<@teile; $i++)
    {
         if ($teile[$i] eq "..")
   	  {
   	     $teile[$i] = "";
   	     $kindex = 1;
	     while (($teile[$i-$kindex] eq "") && ($i-$kindex>1))  # letzteres verhindert Endlosschleife
	     { 
	       $kindex = $kindex + 1;   # Index des letzten nichtleeren Teils
	     }
	     $teile[$i-$kindex] = "";  # den letzten Teil, der nicht leer ist, entfernen,
	                               # um auch Strukturen wie A/../../B zu erfassen
	  }
    }
    $url_aux="";
    foreach $k (@teile)  { $url_aux = "$url_aux/$k"; }
    $url_aux =~ s/\/http/http/;
    while ($url_aux =~ /\/\//)
    { $url_aux =~ s/\/\//\//; }    # Mehrfach-Slashes entfernen
    $url_aux =~ s/http:\//http:\/\//;
    return $url_aux;
}


sub gibtsschon
{  
    $existiertbereits ="";
    $origname = $Filename;	
    $umbenennen = 0;
    while (gibts_checken($Filename) eq "ja")
    {
	    $umbenennen = 1;
	    $existiertbereits = "<FONT FACE='Arial,Helvetica' SIZE='-1'><B>Achtung</B>: Eine Datei namens ".
		                "<FONT FACE='Courier' SIZE='-1'>$origname</FONT> existiert bereits: Der Name wurde in ".
			        "<FONT FACE='Courier' SIZE='-1'>~$Filename</FONT> ge&auml;ndert.</FONT><BR>";
            $Filename = "~$Filename";       
    }
    push(@filenamen,$Filename);  # jeden neuen Filenamen fr zuknftige Checks dazugeben
	                             # (da Dateien aus verschiedenen Verzeichnissen ja gleich heissen knnen)
    $existiert{$File_Handle} = $existiertbereits;
}

sub gibts_checken
{
  # Schauen, ob's am Server schon ein File gleichen Namens schon gibt,
  # oder ob der Name mit einem bereits gespeicherten File kollidiert
    $gibts = "nein";
    foreach $j (@filenamen) 
    {
       if ($j eq $_[0]) { $gibts = "ja"; }
    }	
    return $gibts;
}

sub auslassen
{
   # doppelte Formwerte (d.h. 2x dasselbe File abschicken) ausschliessen
   $ausl = 0;
   foreach $u (@bisherigequeryparams) { if ($u eq $_[0]) 
                                          { $ausl = 1;
                                            $doppelt = 1; 
									      } 
							          }
   return $ausl;
}
