#!/usr/local/bin/perl

if ($ENV{'REQUEST_METHOD'} eq 'GET') 
{ 
   @pairs = split(/&/,$ENV{'QUERY_STRING'}); 
}
elsif ($ENV{'REQUEST_METHOD'} eq 'POST') 
{  
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   @pairs = split(/&/, $buffer);
   
   if($ENV{QUERY_STRING}) 
   {
      @getpairs = split(/&/,$ENV{'QUERY_STRING'});
      push(@pairs,@getpairs);
   }
}

foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $FORM{$name} = $value;
}

$ausgangsverzeichnis = $FORM{'ausgangsverzeichnis'};
$dateien = $FORM{'dateien'};
$dateien =~ s/\#\-\#$//;        #  ein #-# am Ende wegzwicken
@dats = split(/#-#/,$dateien);
$anzahl = @dats;

$zielverzeichnis = $FORM{'zielverzeichnis'};
$modus = $FORM{'modus'};

require 'verz_check.cgi';
&berechtigung_checken($zielverzeichnis); # ldt @filenamen vom Zielverzeichnis

$mitzaehlen_versch = 0;
$mitzaehlen_kop = 0;
$fehler = 0;

foreach $herkunft (@dats)
{
 $ziel = $herkunft;
 $ziel =~ s/$ausgangsverzeichnis/$zielverzeichnis/;

 $objektname = $herkunft;
 $objektname =~ s/$ausgangsverzeichnis//;
 # gegen mibruchliche Verwendung:
 $objektname =~ s/\///g;  # zur Sicherheit Slashes weg
 $objektname =~ s/^\.+//;  # zur Sicherheit Punkte am Anfang weg
 $objektname =~ s/^(index)+//i;  # zur Sicherheit index (ggf fters)am Anfang weg

 if (-e $herkunft) # falls das Herkunftsobjekt existiert
 { 
	  if (-d $herkunft)  # falls Verzeichnis
	  { 
	   $verzz = 1;
	  }   
	  elsif (-f $herkunft)  # falls Datei
	  { 
	   $verzz = 0;
	  }
 
      if ($herkunft ne $ziel)
	  {
	    # Gibt's ein gleichnamiges File schon? Dann eine Tilde (~) voranstellen
	    while (gibts_checken($objektname) eq "ja")
        {
	     $objektname = "~$objektname";
	     $ziel = "$zielverzeichnis/$objektname";
	    }
	    rename($herkunft,$ziel);   # umbenennen
		# Checken:
		if (-e $ziel) { $mitzaehlen_versch = $mitzaehlen_versch + 1; }
      }

  # Sofern existiert, Titel in das Berechtigungs-File schreiben (anhngen):
   require "$ausgangsverzeichnis/.06641431691"; 
   if (exists $_titel_{$objektname})
   {
    $altertitel = $_titel_{$objektname};
    open(FILE_SCHREIBEN,">>$zielverzeichnis/.06641431691");
    flock(FILE_SCHREIBEN, 2);   
    print FILE_SCHREIBEN "\n\$_titel_{\"$objektname\"} = \"$altertitel\";  \# $aktuelle_zeit";   
    flock(FILE_SCHREIBEN, 8);
    close(FILE_SCHREIBEN);   
   }
   
# Falls Datei und falls modus = kopieren, dann auch kopieren
  if (($modus eq "kopieren") && (-f $ziel) && (!(-e $herkunft)))
  {
      open(FILE_LESEN,"<$ziel");
      flock(FILE_LESEN, 2);
      @inhaltvonziel = <FILE_LESEN>;   # enthlt die einzelnen Zeilen
      flock(FILE_LESEN, 8);
      close(FILE_LESEN);  
  
    open(FILE_SCHREIBEN,">$herkunft");
    flock(FILE_SCHREIBEN, 2);   
	foreach $zeile (@inhaltvonziel)
    { print FILE_SCHREIBEN $zeile; }
    flock(FILE_SCHREIBEN, 8);
    close(FILE_SCHREIBEN);     
	
	@inhaltvonziel = "";
  
  # Checken:
  if (-e $herkunft) { $mitzaehlen_kop = $mitzaehlen_kop + 1;  }
  }
   
 }
 else
 {
 $fehler = $fehler + 1;
 print "Content-type: text/html\n\n";
 print <<"LABEL_FEHLER";

<HTML><HEAD><TITLE>Fehler!</TITLE></HEAD>
<BODY LINK="#0000CC" VLINK="#000099" ALINK="#009999"><A NAME="top"><FONT FACE="Arial,Helvetica" SIZE="-1">
<NOBR>
&nbsp;&nbsp;&nbsp;<B>Fehler:</B>&nbsp;
Eines der angegebenen Objekte scheint nicht zu existieren!
&nbsp;&nbsp;&nbsp;&nbsp;<A HREF="javascript:history.back()">Zur&uuml;ck</A>
</NOBR>
</FONT>
</BODY>
</HTML>

LABEL_FEHLER
exit; 
 }
}

$eswurde = "Es wurde";
if ($mitzaehlen_versch eq 0) { $meldung = " kein Objekt verschoben"; }
elsif ($mitzaehlen_versch eq 1) { $meldung = " ein Objekt verschoben"; }
else { $meldung = "n $mitzaehlen_versch Objekte verschoben"; }

if ($mitzaehlen_kop eq 0) { $meldung = $meldung."."; }
elsif ($mitzaehlen_kop eq 1) { $meldung = $meldung.", davon eines kopiert."; }
else { $meldung = $meldung.", davon $mitzaehlen_kop Objekte kopiert."; }

print "Content-type: text/html\n\n";
print <<"LABEL_RUECKM";

<HTML><HEAD><TITLE>$meldung</TITLE></HEAD>
<SCRIPT LANGUAGE="JavaScript">
top.Links.document.location = top.Links.document.location ;
top.Rechts.document.location = top.Rechts.document.location ;
window.top.opener.schliessen=0
window.top.opener.location = window.top.opener.location;
</SCRIPT>
<BODY LINK="#0000CC" VLINK="#000099" ALINK="#009999"><A NAME="top"><FONT FACE="Arial,Helvetica" SIZE="-1">
<BR><NOBR>&nbsp;&nbsp;&nbsp;<B>$eswurde$meldung</B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<A HREF="javascript:history.back()">Zur&uuml;ck</A></NOBR>
</FONT></BODY></HTML>
LABEL_RUECKM

sub gibts_checken
{
    $gibts = "nein";
    foreach $f (@filenamen) 
    {
       if ($f eq $_[0]) { $gibts = "ja"; }
    }	
    return $gibts;
}
