#!/usr/local/bin/perl

if ($ENV{'REQUEST_METHOD'} eq 'GET') 
{ 
   @pairs = split(/&/,$ENV{'QUERY_STRING'}); 
}
elsif ($ENV{'REQUEST_METHOD'} eq 'POST') 
{  
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   @pairs = split(/&/, $buffer);
   
   if($ENV{QUERY_STRING}) 
   {
      @getpairs = split(/&/,$ENV{'QUERY_STRING'});
      push(@pairs,@getpairs);
   }
}

foreach $pair (@pairs)
{
    ($name, $value) = split(/=/, $pair);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $FORM{$name} = $value;
}

$relativer_pfad = $FORM{'pfd'};
$zeit_alt = $FORM{'zeit'};
$ueberschreiben = $FORM{'ueberschreiben'};
$neuesdok = $FORM{'neuesdok'};
$original = $FORM{'original'};

# Berechtigung checken und @filenamen ermitteln 
require 'verz_check.cgi';
&berechtigung_checken($relativer_pfad); 

require "$relativer_pfad/.06641431691"; 

$neu = $FORM{'fl'};  # Name, unter dem die Datei abzuspeichern ist (Vorschlag)
 
    $neu =~ s/^\s+//;       # Leerzeichen am Anfang entfernen
    $neu =~ s/^\.+//;       # Punkte am Anfang werden weggezwickt
	$neu =~ s/^\s+//;       # nochmals Leerzeichen am Anfang entfernen
    $neu =~ s/(\s+)$//;     # Leerzeichen am Ende entfernen
    $neu =~ s/ /_/g;        # Leerzeichen in der Mitte durch _ ersetzen
    $neu =~ s/^\.+//;       # nochmals: Punkte am Anfang werden weggezwickt

 if ( !($neu =~ /^\s*$/)                     # nicht leer
	 && !($neu =~ /\//) && !($neu =~ /\\/)  # keine Slashes und Backslashes
	 && !($neu =~ /^index/i)                # beginnt nicht mit 'index' 
     && !($neu =~ /\&/) && !($neu =~ /\+/) 
 	 && !($neu =~ /\?/) && !($neu =~ /;/)   # ; muss schon auf der Webseite abgefangen werden
 	 && !($neu =~ /\%/) && !($neu =~ /\#/) 
 	 && !($neu =~ /\=/) && !($neu =~ /\"/)   # " muss schon auf der Webseite abgefangen werden
	 && !($neu =~ /\'/)                      # ' muss schon auf der Webseite abgefangen werden
 )
{
  $alt = $neu;
   
  $warnung ="";
  $zeit_aktuell = (stat("$relativer_pfad/$neu"))[9];   
  $differenz = $zeit_aktuell - $zeit_alt;
  
  # Falls eine existierende Datei unter demselben Namen gespeichert wird,
  # berschreiben angeklickt war und die Datei mittlerweile von jemand anderem gendern wurde:
  # Falls neues Dokument angelegt wird, sind $zeit_aktuell und $zeit_alt nicht definiert. und es 
  # ergibt sich $differenz=0, also keine Warnung.
    
  if (($neu eq $original) && ($neuesdok ne "1") && ($ueberschreiben eq "on") && ($differenz ne 0))   
  { 
  # Jetzt als Differenz der letzten nderung zu jetzt definieren:
  $differenz = time - $zeit_aktuell;

  ($xsec,$xmin,$xhour,$xmday,$xmon,$xyear,$xwday,$xyday,$xisdst)=localtime($differenz);
   $xstunde = $xhour - 1;  # wegen der konkreten Art der Stundenzhlung
          
          if ($differenz < 60)
           {
             $differenz_txt = $differenz."*Sekunden";  
           }
           elsif (($differenz < 86400) && ($xstunde eq 0))
           {
             if ($xmin eq 1) { if ($xsec eq 1) { $differenz_txt ="1*Minute*1*Sekunde"; }
                               else { $differenz_txt ="1*Minute*".$xsec."*Sekunden"; } }
             else {  if ($xsec eq 1) { $differenz_txt =$xmin."*Minuten*1*Sekunde"; }
                     else { $differenz_txt =$xmin."*Minuten*".$xsec."*Sekunden"; } }
           }
           elsif ($differenz < 86400)
           {
		     if ($xstunde < 0) { $xstunde = $xstunde + 24; }
             if ($xstunde eq 1) { if ($xmin eq 1) { $differenz_txt ="1*Stunde*1*Minute"; }
                                  else  { $differenz_txt ="1*Stunde*".$xmin."*Minuten";} }
             else {  if ($xmin eq 1) { $differenz_txt =$xstunde."*Stunden*1*Minute"; }
                     else {$differenz_txt =$xstunde."*Stunden*".$xmin."*Minuten"; } }
           }
           else
           {
             $differenz_txt = "mehr*als*einem*Tag*oder*in*einer*unerwarteten*Weise";
           }

	   # Gibt's ein gleichnamiges File schon? Dann eine Tilde (~) voranstellen
	   while (gibts_checken($neu) eq "ja")
           {
	     $neu = "~$neu";
	   }
	   
     if ($neu eq $alt)       # Falls keine nderung stattgefunden hat, gibt es die Datei nicht mehr!
	 {
     $warnung = "<SCRIPT LANGUAGE='JavaScript'>\n".
     "warn = window.open('$scriptverzeichnis/warnung.cgi?pfd=$relativer_pfad&alt=$alt&neu=$neu&typ=1','_blank','width=550,height=194,resizable=yes,status=no,menubar=no,scrollbars=yes,location=no');\n".
#     "warn.document.write('<HTML><HEAD><TITLE>Dokument wurde w&auml;hrend der Bearbeitung gel&ouml;scht</TITLE></HEAD>');\n".
#     "warn.document.write('<BODY BGCOLOR=\"#FFFF99\" LINK=\"#0000CC\" VLINK=\"#000099\" ALINK=\"#009999\"><FONT FACE=\"Arial,Helvetica\" SIZE=\"-1\">');\n".
#     "warn.document.write('<FONT SIZE=\"+0\"><B>Achtung</B></FONT>:<BR><BR>');\n".
#     "warn.document.write('Die Datei <B>$alt</B> ');\n".
#     "warn.document.write('wurde w&auml;hrend der Bearbeitung von einem anderen Proze&szlig; gel&ouml;scht! Die ');\n".
#     "warn.document.write('neue Version Dokument wurde unter dem Namen');\n".
#     "warn.document.write('<CENTER><BR><A HREF=\"$relativer_pfad/$neu\" TARGET=\"_blank\">$neu</A></CENTER><BR>');\n".
#     "warn.document.write('gespeichert. <DIV ALIGN=\"right\"><A HREF=\"javascript: window.close();\">Schlie&szlig;en</A>&nbsp;&nbsp;&nbsp;&nbsp;</DIV>');\n".
#     "warn.document.write('</FONT></BODY></HTML>');\n".
     "warn.focus();\n".
     "</SCRIPT>\n";
	 }
	 else
     {
     $warnung = "<SCRIPT LANGUAGE='JavaScript'>\n".
     "warn = window.open('$scriptverzeichnis/warnung.cgi?pfd=$relativer_pfad&alt=$alt&neu=$neu&differenz_txt=$differenz_txt&typ=2','_blank','width=550,height=194,resizable=yes,status=no,menubar=no,scrollbars=yes,location=no');\n".
#     "warn.document.write('<HTML><HEAD><TITLE>Dokument wurde nicht &uuml;berschrieben</TITLE></HEAD>');\n".
#     "warn.document.write('<BODY BGCOLOR=\"#FFFF99\" LINK=\"#0000CC\" VLINK=\"#000099\" ALINK=\"#009999\"><FONT FACE=\"Arial,Helvetica\" SIZE=\"-1\">');\n".
#     "warn.document.write('<FONT SIZE=\"+0\"><B>Achtung</B></FONT>:<BR><BR>');\n".
#     "warn.document.write('Die Datei <A HREF=\"$relativer_pfad/$alt\" TARGET=\"_blank\">$alt</A> ');\n".
#     "warn.document.write('wurde w&auml;hrend der Bearbeitung (vor $differenz_txt) von einem anderen Proze&szlig; verndert! Das ');\n".
#     "warn.document.write('Dokument wurde <I>nicht</I> &uuml;berschrieben, sondern unter dem neuen Namen');\n".
#     "warn.document.write('<CENTER><BR><A HREF=\"$relativer_pfad/$neu\" TARGET=\"_blank\">$neu</A></CENTER><BR>');\n".
#     "warn.document.write('gespeichert. <DIV ALIGN=\"right\"><A HREF=\"javascript: window.close();\">Schlie&szlig;en</A>&nbsp;&nbsp;&nbsp;&nbsp;</DIV>');\n".
#     "warn.document.write('</FONT></BODY></HTML>');\n".
     "warn.focus();\n".
     "</SCRIPT>\n";
	 }
  }
   
  elsif ($ueberschreiben ne "on")
  {
	  # Gibt's ein gleichnamiges File schon? Dann eine Tilde (~) voranstellen
	  while (gibts_checken($neu) eq "ja")
          {
	    $neu = "~$neu";
	  }
  }
   
 # Speichern:
 
   open(FILE_SCHREIBEN,">$relativer_pfad/$neu");
   flock(FILE_SCHREIBEN, 2);   
   print FILE_SCHREIBEN $FORM{'editfile'};
   flock(FILE_SCHREIBEN, 8);
   close(FILE_SCHREIBEN);

   chmod (0666, "$relativer_pfad/$neu");   

   if ($ueberschreiben ne "on")
   {
   # Default-Titel in das Berechtigungs-File schreiben (anhngen):
   open(FILE_SCHREIBEN,">>$relativer_pfad/.06641431691");
   flock(FILE_SCHREIBEN, 2);   
   print FILE_SCHREIBEN "\n\$_titel_{\"$neu\"} = \"Datei $neu\";  \# $aktuelle_zeit";    # Titel eintragen
   flock(FILE_SCHREIBEN, 8);
   close(FILE_SCHREIBEN);
   }
   else     # falls berschreiben gewnscht
   {
   # alten Titel im Berechtigungs-File bernehmen:  
   open(FILE_SCHREIBEN,">>$relativer_pfad/.06641431691");
   flock(FILE_SCHREIBEN, 2);   
   if (exists $_titel_{"$alt"})
      { print FILE_SCHREIBEN "\n\$_titel_{\"$neu\"} = \$_titel_{\"$alt\"};  \# $aktuelle_zeit"; }   # alten Titel bernehmen
   else	   
      { print FILE_SCHREIBEN "\n\$_titel_{\"$neu\"} = \"Datei $neu\";  \# $aktuelle_zeit"; }   # Default-Titel eintragen	  
	  
   flock(FILE_SCHREIBEN, 8);
   close(FILE_SCHREIBEN);   
   }

print "Content-type: text/html\n\n";
print <<"LABEL_SEITE";

<HTML><HEAD><TITLE>Datei wurde gespeichert!</TITLE></HEAD>
<BODY LINK="#0000CC" VLINK="#000099" ALINK="#009999"><A NAME="top"><FONT FACE="Arial,Helvetica">
$warnung
<BR><BR><BR><BR><BR><BR>
<CENTER>
<H1>Die Datei wurde gespeichert</H1>
</CENTER>
<BR><BR>
<SCRIPT LANGUAGE="JavaScript">
window.opener.location = window.opener.location;
window.close();
</SCRIPT>
</FONT>
</BODY>
</HTML>

LABEL_SEITE
}
else
{
print "Content-type: text/html\n\n";
print <<"LABEL_FEHLER";

<HTML><HEAD><TITLE>Datei wurde nicht gespeichert!</TITLE></HEAD>
<BODY LINK="#0000CC" VLINK="#000099" ALINK="#009999"><A NAME="top"><FONT FACE="Arial,Helvetica" SIZE="-1">
<BR><BR><BR><BR><BR><BR><BR><BR>
<CENTER>
<FONT SIZE="+0"><B>Die Datei wurde nicht gespeichert!</B></FONT>
<BR>
<TABLE WIDTH="95%"><TD><FONT FACE="Arial,Helvetica" SIZE="-1">
Ein Dateiname darf 
<UL>
<LI>nicht leer sein und
<LI>keine Sonderzeichen wie Schr&auml;gstriche (&nbsp;/ und &#92;&nbsp;),
Anf&uuml;hrungszeichen (&nbsp;" und '&nbsp;) und die Symbole &amp;, +, ?, ;, %, # und = 
enthalten.
</UL>

Beginnt der Name mit Punkten, so werden diese ignoriert.
Leerzeichen werden durch das Symbol&nbsp;_ ersetzt.
</FONT></TD></TABLE>
<BR><BR>
<CENTER><A HREF="javascript:history.back()">Zur&uuml;ck</A></CENTER>
</FONT>
</BODY>
</HTML>

LABEL_FEHLER
}


sub gibts_checken
{
    $gibts = "nein";
    foreach $f (@filenamen) 
    {
       if ($f eq $_[0]) { $gibts = "ja"; }
    }	
    return $gibts;
}
